# How to update the input parser...

## ...when you have updated the `Constants` input section
The `Constants` section require a bit of special treatment, because the constants are derived from NIST data via an interface
to `qcelemental`. 
All constants should be defined in the class `MRChemPhysConstants` located in `python/mrchem/physical_constants.py`.
The utility script `python/mrchem/update_input_parser.py` will automatically replace the current `Constants`
section in `python/template.yml` with a new one generated by instantiating `MRChemPhysConstants` and
reading the subset of constants defined therein.

To run the script:

```bash
$ cd python/mrchem
$ python update_input_parser.py
```

This does three things:

1. Update `template.yml` with the new `Constants` section
2. Run `parselglossy` to update the input parser
3. Copy the user reference file to `doc/users/user_ref.rst`

Each of these steps can be deactivated by appropriate flags. For help on running the script, run

```bash
$ cd python
$ python update_input_parser.py -h
```

## ...when you have updated any other input section
If the `Constants` input section is unchanged, you can update the input parser by performing steps 2 and 3 above.
The utility script can also do this, by specifying the flag `--skip-template`:

```bash
$ cd python
$ python update_input_parser --skip-template
```

This will perform steps 2-3, updating the input parser and the user reference.

You can also perform these steps manually without using the utility script:

```bash
$ cd python
$ parselglossy generate --template template.yml --docfile user_ref.rst --doc-header="User input reference" --target="mrchem/input_parser"
$ cp mrchem/input_parser/docs/user_ref.rst ../doc/users/user_ref.rst
```
